Reference For: developers

API: customization

Operations of the customization tag of the native REST API.

GET /v1/customization/specs

GET /v1/customization/specs

CLI
kyvernon customization list

Responses

StatusDescriptionSchema
200Customization specificationsarray of CustomizationSpecView

POST /v1/customization/specs

POST /v1/customization/specs

CLI
kyvernon customization create --body <json>

Request body

application/json: CreateCustomizationSpecRequest

NameTypeRequiredDescription
descriptionstring or nullOptional description.
dnsServersarray of string or nullDNS servers.
dnsSuffixesarray of string or nullDNS search suffixes.
domainstring or nullDNS domain.
domainAdminstring or nullDomain-join account name.
domainAdminPasswordstring or nullDomain-join account password (stored; never returned on GET).
domainOustring or nullOptional target OU DN.
fullNamestring or nullWindows registered owner.
hostnamestring or nullFixed host name.
joinDomainstring or nullAD domain to join.
joinWorkgroupstring or nullWorkgroup when not joining a domain.
metadatastring or nullRaw cloud-init metadata (overrides hostname synthesis when set).
namestringyesSpec name (1..=80; ignored on PUT path overwrite in favour of the path).
nicsarray of CustomizationNicSetting or nullNIC mappings (static IP / DHCP).
orgNamestring or nullWindows organisation.
passwordstring or nullPlaintext guest password (stored; never returned on GET).
sshUserstring or nullOptional SSH username that also receives the password.
timezonestring or nullTimezone.
typestring or nullGuest OS family (Linux or Windows); defaults to Linux.
unattendstring or nullRaw unattend.xml for Windows (stored; never returned on GET).
userdatastring or nullRaw cloud-init user-data (overrides synthesized user-data when set).

Responses

StatusDescriptionSchema
201Created specificationCustomizationSpecView

GET /v1/customization/specs/{name}

GET /v1/customization/specs/{name}

CLI
kyvernon customization get <name>

Parameters

NameInTypeRequiredDescription
namepathstringyesSpecification name

Responses

StatusDescriptionSchema
200SpecificationCustomizationSpecView

PUT /v1/customization/specs/{name}

PUT /v1/customization/specs/{name}

CLI
kyvernon customization overwrite <name> --body <json>

Parameters

NameInTypeRequiredDescription
namepathstringyesSpecification name

Request body

application/json: CreateCustomizationSpecRequest

NameTypeRequiredDescription
descriptionstring or nullOptional description.
dnsServersarray of string or nullDNS servers.
dnsSuffixesarray of string or nullDNS search suffixes.
domainstring or nullDNS domain.
domainAdminstring or nullDomain-join account name.
domainAdminPasswordstring or nullDomain-join account password (stored; never returned on GET).
domainOustring or nullOptional target OU DN.
fullNamestring or nullWindows registered owner.
hostnamestring or nullFixed host name.
joinDomainstring or nullAD domain to join.
joinWorkgroupstring or nullWorkgroup when not joining a domain.
metadatastring or nullRaw cloud-init metadata (overrides hostname synthesis when set).
namestringyesSpec name (1..=80; ignored on PUT path overwrite in favour of the path).
nicsarray of CustomizationNicSetting or nullNIC mappings (static IP / DHCP).
orgNamestring or nullWindows organisation.
passwordstring or nullPlaintext guest password (stored; never returned on GET).
sshUserstring or nullOptional SSH username that also receives the password.
timezonestring or nullTimezone.
typestring or nullGuest OS family (Linux or Windows); defaults to Linux.
unattendstring or nullRaw unattend.xml for Windows (stored; never returned on GET).
userdatastring or nullRaw cloud-init user-data (overrides synthesized user-data when set).

Responses

StatusDescriptionSchema
200Updated specificationCustomizationSpecView

DELETE /v1/customization/specs/{name}

DELETE /v1/customization/specs/{name}

CLI
kyvernon customization delete <name>

Parameters

NameInTypeRequiredDescription
namepathstringyesSpecification name

Responses

StatusDescriptionSchema
204Deleted

Version 0.1.